summaryrefslogtreecommitdiff
diff options
context:
space:
mode:
authorLars Wirzenius <lars.wirzenius@codethink.co.uk>2012-03-26 15:12:07 +0100
committerLars Wirzenius <lars.wirzenius@codethink.co.uk>2012-03-26 15:12:07 +0100
commit7d7d597afd0a562916f106d259f4ff78383f9631 (patch)
treec7c188f5905310331a31e6e70aa87e3d72089d17
parent712ac2bcd856c864e34c337fc23fe86216a88049 (diff)
downloadmorph-7d7d597afd0a562916f106d259f4ff78383f9631.tar.gz
Separate tests that need to be run as root in their own directory
-rwxr-xr-xcheck4
-rw-r--r--tests.as-root/hello-chunk.tar.gzbin0 -> 12596 bytes
-rw-r--r--tests.as-root/hello-stratum.morph10
-rwxr-xr-xtests.as-root/make-patch.script (renamed from tests/make-patch.script)0
-rw-r--r--tests.as-root/make-patch.stderr (renamed from tests/make-patch.stderr)0
-rw-r--r--tests.as-root/make-patch.stdout (renamed from tests/make-patch.stdout)0
-rwxr-xr-xtests.as-root/morph29
-rwxr-xr-xtests.as-root/setup128
8 files changed, 171 insertions, 0 deletions
diff --git a/check b/check
index 5fe8df0f..0b37fb58 100755
--- a/check
+++ b/check
@@ -21,6 +21,10 @@ set -e
python setup.py clean check
cmdtest tests
+if [ $(whoami) = root ] && command -v mkfs.btrfs > /dev/null
+then
+ cmdtest tests.as-root
+fi
if [ -d .git ];
then
diff --git a/tests.as-root/hello-chunk.tar.gz b/tests.as-root/hello-chunk.tar.gz
new file mode 100644
index 00000000..91e27347
--- /dev/null
+++ b/tests.as-root/hello-chunk.tar.gz
Binary files differ
diff --git a/tests.as-root/hello-stratum.morph b/tests.as-root/hello-stratum.morph
new file mode 100644
index 00000000..11ac4e1c
--- /dev/null
+++ b/tests.as-root/hello-stratum.morph
@@ -0,0 +1,10 @@
+{
+ "name": "hello",
+ "kind": "stratum",
+ "sources": {
+ "hello": {
+ "repo": "hello",
+ "ref": "master"
+ }
+ }
+}
diff --git a/tests/make-patch.script b/tests.as-root/make-patch.script
index cc2af3b6..cc2af3b6 100755
--- a/tests/make-patch.script
+++ b/tests.as-root/make-patch.script
diff --git a/tests/make-patch.stderr b/tests.as-root/make-patch.stderr
index 9ed08116..9ed08116 100644
--- a/tests/make-patch.stderr
+++ b/tests.as-root/make-patch.stderr
diff --git a/tests/make-patch.stdout b/tests.as-root/make-patch.stdout
index e8bb667c..e8bb667c 100644
--- a/tests/make-patch.stdout
+++ b/tests.as-root/make-patch.stdout
diff --git a/tests.as-root/morph b/tests.as-root/morph
new file mode 100755
index 00000000..8ba3ae78
--- /dev/null
+++ b/tests.as-root/morph
@@ -0,0 +1,29 @@
+#!/bin/sh
+#
+# Run morph in a way suitable for tests.
+#
+# Copyright (C) 2012 Codethink Limited
+#
+# This program is free software; you can redistribute it and/or modify
+# it under the terms of the GNU General Public License as published by
+# the Free Software Foundation; version 2 of the License.
+#
+# This program is distributed in the hope that it will be useful,
+# but WITHOUT ANY WARRANTY; without even the implied warranty of
+# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
+# GNU General Public License for more details.
+#
+# You should have received a copy of the GNU General Public License along
+# with this program; if not, write to the Free Software Foundation, Inc.,
+# 51 Franklin Street, Fifth Floor, Boston, MA 02110-1301 USA.
+
+set -eu
+
+fatalcat(){
+ cat "$1" 1>&2
+ return 1
+}
+
+PATH="$(pwd):$PATH"
+./morph --no-default-config --config="$DATADIR/morph.conf" "$@" || \
+ fatalcat "$DATADIR/morph.log"
diff --git a/tests.as-root/setup b/tests.as-root/setup
new file mode 100755
index 00000000..004c0ceb
--- /dev/null
+++ b/tests.as-root/setup
@@ -0,0 +1,128 @@
+#!/bin/sh
+#
+# Create git repositories for tests. The chunk repository will contain a
+# simple "hello, world" C program, and two branches ("master", "farrokh"),
+# with the master branch containing just a README. The two branches are there
+# so that we can test building a branch that hasn't been checked out.
+# The branches are different so that we know that if the wrong branch
+# is uses, the build will fail.
+#
+# The stratum repository contains a single branch, "master", with a
+# stratum and a system morphology that include the chunk above.
+#
+# Copyright (C) 2011, 2012 Codethink Limited
+#
+# This program is free software; you can redistribute it and/or modify
+# it under the terms of the GNU General Public License as published by
+# the Free Software Foundation; version 2 of the License.
+#
+# This program is distributed in the hope that it will be useful,
+# but WITHOUT ANY WARRANTY; without even the implied warranty of
+# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
+# GNU General Public License for more details.
+#
+# You should have received a copy of the GNU General Public License along
+# with this program; if not, write to the Free Software Foundation, Inc.,
+# 51 Franklin Street, Fifth Floor, Boston, MA 02110-1301 USA.
+
+
+set -eu
+
+# The $DATADIR should be empty at the beginnig of each test.
+find "$DATADIR" -mindepth 1 -delete
+
+# Create chunk repository.
+
+chunkrepo="$DATADIR/chunk-repo"
+mkdir "$chunkrepo"
+cd "$chunkrepo"
+git init --quiet
+
+cat <<EOF > README
+This is a sample README.
+EOF
+git add README
+git commit --quiet -m "add README"
+
+git checkout --quiet -b farrokh
+
+cat <<EOF > hello.c
+#include <stdio.h>
+int main(void)
+{
+ puts("hello, world");
+ return 0;
+}
+EOF
+git add hello.c
+
+cat <<EOF > hello.morph
+{
+ "name": "hello",
+ "kind": "chunk",
+ "build-system": "dummy",
+ "build-commands": [
+ "gcc -o hello hello.c"
+ ],
+ "install-commands": [
+ "install -d \\"\$DESTDIR\\"/etc",
+ "install -d \\"\$DESTDIR\\"/bin",
+ "install hello \\"\$DESTDIR\\"/bin/hello"
+ ]
+}
+EOF
+git add hello.morph
+
+git commit --quiet -m "add a hello world program and morph"
+
+git checkout --quiet master
+
+
+
+# Create morph repository.
+
+morphsrepo="$DATADIR/morphs-repo"
+mkdir "$morphsrepo"
+cd "$morphsrepo"
+git init --quiet
+
+cat <<EOF > hello-stratum.morph
+{
+ "name": "hello-stratum",
+ "kind": "stratum",
+ "sources": [
+ {
+ "name": "hello",
+ "repo": "chunk-repo",
+ "ref": "farrokh"
+ }
+ ]
+}
+EOF
+git add hello-stratum.morph
+
+cat <<EOF > hello-system.morph
+{
+ "name": "hello-system",
+ "kind": "system",
+ "disk-size": "1G",
+ "strata": [
+ "hello-stratum"
+ ]
+}
+EOF
+git add hello-system.morph
+
+git commit --quiet -m "add morphs"
+
+
+# Create a morph configuration file.
+cat <<EOF > "$DATADIR/morph.conf"
+[config]
+git-base-url = file://$DATADIR/
+cachedir = $DATADIR/cache
+log = $DATADIR/morph.log
+keep-path = true
+no-distcc = true
+EOF
+